Crystal::Macros::HashLiteral - Crystal 1.20.2

# class Crystal::Macros::HashLiteral

- Crystal::Macros::HashLiteral
- Crystal::Macros::ASTNode

##
Overview

A hash literal.

##
Defined in:

compiler/crystal/macros.cr

##
Instance Method Summary

- #[](key : ASTNode) : ASTNode

  Similar to `Hash#[]?`

- #[]=(key : ASTNode, value : ASTNode) : ASTNode

  Similar to `Hash#[]=`

- #clear : HashLiteral

  Similar to `Hash#clear`

- #double_splat(trailing_string : StringLiteral = nil) : MacroId

  Returns a `MacroId` with all of this hash elements joined by commas.

- #each(&) : NilLiteral

  Similar to `Hash#each`

- #empty? : BoolLiteral

  Similar to `Hash#empty?`

- #has_key?(key : ASTNode) : BoolLiteral

  Similar to `Hash#has_hey?`

- #keys : ArrayLiteral

  Similar to `Hash#keys`

- #map(&) : ArrayLiteral

  Similar to `Hash#map`

- #of_key : ASTNode | Nop

  Returns the type specified at the end of the Hash literal, if any.

- #of_value : ASTNode | Nop

  Returns the type specified at the end of the Hash literal, if any.

- #reject(&) : HashLiteral

  Similar to `Hash#reject`

- #reject(*keys : ASTNode) : HashLiteral

  Returns a new `HashLiteral` without the provided keys.

- #select(&) : HashLiteral

  Similar to `Hash#select`

- #select(*keys : ASTNode) : HashLiteral

  Returns a new `HashLiteral` with only the provided keys.

- #size : NumberLiteral

  Similar to `Hash#size`

- #to_a : ArrayLiteral(TupleLiteral)

  Similar to `Hash#to_a`

- #type : Path | Nop

  Returns the type that receives the items of the array.

- #values : ArrayLiteral

  Similar to `Hash#values`

### Instance methods inherited from class `Crystal::Macros::ASTNode`

!=(other : ASTNode) : BoolLiteral !=, ==(other : ASTNode) : BoolLiteral ==, class_name : StringLiteral class_name, column_number : StringLiteral | NilLiteral column_number, doc : StringLiteral doc, doc_comment : MacroId doc_comment, end_column_number : StringLiteral | NilLiteral end_column_number, end_line_number : StringLiteral | NilLiteral end_line_number, filename : StringLiteral | NilLiteral filename, id : MacroId id, is_a?(type : TypeNode) : BoolLiteral is_a?, line_number : StringLiteral | NilLiteral line_number, nil? : BoolLiteral nil?, raise(message) : NoReturn raise, stringify : StringLiteral stringify, symbolize : SymbolLiteral symbolize, warning(message : StringLiteral) : NilLiteral warning

##
Instance Method Detail

def [](key : ASTNode) : ASTNode #

Similar to `Hash#[]?`

def []=(key : ASTNode, value : ASTNode) : ASTNode #

Similar to `Hash#[]=`

def clear : HashLiteral #

Similar to `Hash#clear`

def double_splat(trailing_string : StringLiteral = nil) : MacroId #

Returns a `MacroId` with all of this hash elements joined by commas.

If trailing_string is given, it will be appended to the result unless this hash is empty. This lets you splat a hash and optionally write a trailing comma if needed.

def each(&) : NilLiteral #

Similar to `Hash#each`

def empty? : BoolLiteral #

Similar to `Hash#empty?`

def has_key?(key : ASTNode) : BoolLiteral #

Similar to `Hash#has_hey?`

def keys : ArrayLiteral #

Similar to `Hash#keys`

def map(&) : ArrayLiteral #

Similar to `Hash#map`

def of_key : ASTNode | Nop #

Returns the type specified at the end of the Hash literal, if any.

This refers to the key type after brackets in `{} of String => Int32`.

def of_value : ASTNode | Nop #

Returns the type specified at the end of the Hash literal, if any.

This refers to the value type after brackets in `{} of String => Int32`.

def reject(&) : HashLiteral #

Similar to `Hash#reject`

def reject(*keys : ASTNode) : HashLiteral #

Returns a new `HashLiteral` without the provided keys.

def select(&) : HashLiteral #

Similar to `Hash#select`

def select(*keys : ASTNode) : HashLiteral #

Returns a new `HashLiteral` with only the provided keys.

def size : NumberLiteral #

Similar to `Hash#size`

def to_a : ArrayLiteral(TupleLiteral) #

Similar to `Hash#to_a`

def type : Path | Nop #

Returns the type that receives the items of the array.

This refers to the part before brackets in `MyHash{'a' => 1, 'b' => 2}`

def values : ArrayLiteral #

Similar to `Hash#values`